=== debian/changelog ===
texworks (0.6.6-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:35:44 +0000

texworks (0.6.6-2) unstable; urgency=medium

  * The last "debuild -S" run unintentionally picked up the broken
    autopkg test suite. Upload without it.

 -- Hilmar Preusse <hille42@web.de>  Sat, 10 Jul 2021 08:43:19 +0200

texworks (0.6.6-1) unstable; urgency=medium

  * New upstream version 0.6.6.
    - Add qtdeclarative5-dev to B-D, disable all patches.
    - I: texworks: spelling-error-in-binary (not all of them)
    - Add lintian override for E: embedded-library usr/bin/texworks: pcre3

 -- Hilmar Preusse <hille42@web.de>  Fri, 09 Jul 2021 23:54:33 +0200
