=== debian/control ===
Source: texworks
Section: editors
Priority: optional
Maintainer: Debian TeX maintainers <debian-tex-maint@lists.debian.org>
Uploaders: Norbert Preining <norbert@preining.info>,
  Hilmar Preusse <hille42@web.de>
Build-Depends: debhelper-compat (= 12),
 pkg-config,
 cmake (>= 2.8.6),
 libhunspell-dev,
 qtbase5-dev,
 qttools5-dev,
 qtscript5-dev,
 qtdeclarative5-dev,
 libpoppler-qt5-dev,
 liblua5.3-dev | liblua5.2-dev,
 python3-dev,
 zlib1g-dev,
 libsynctex-dev (>= 2018.20180119.46378)
Standards-Version: 4.2.1
Homepage: https://www.tug.org/texworks/
Vcs-Git: https://github.com/debian-tex/texworks.git
Vcs-Browser: https://github.com/debian-tex/texworks

Package: texworks
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gsfonts, poppler-data, texlive-latex-base, texworks-help-en
Suggests: texlive-xetex, texworks-scripting-lua, texworks-scripting-python
Description: Environment for authoring TeX (LaTeX, ConTeXt, etc) documents
 An environment for authoring TeX (LaTeX, ConTeXt, etc) documents, with
 a Unicode-based, TeX-aware editor, integrated PDF viewer, and a clean,
 simple interface accessible to casual and non-technical users.
 .
 TeXworks is inspired by Dick Koch's award-winning TeXShop program for
 Mac OS X, which has made quality typesetting through TeX accessible to
 a wider community of users, without a technical or intimidating face.
 The goal of TeXworks is to deliver a similarly integrated, easy-to-use
 environment for users on other platforms, especially GNU/Linux and Windows.

Package: texworks-scripting-lua
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, texworks
Description: Plugin to bring Lua scripting to TeXworks
 An environment for authoring TeX (LaTeX, ConTeXt, etc) documents, with
 a Unicode-based, TeX-aware editor, integrated PDF viewer, and a clean,
 simple interface accessible to casual and non-technical users.
 .
 This package contains a lua scripting plugin for TeXworks.

Package: texworks-scripting-python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, texworks
Description: Plugin to bring Python scripting to TeXworks
 An environment for authoring TeX (LaTeX, ConTeXt, etc) documents, with
 a Unicode-based, TeX-aware editor, integrated PDF viewer, and a clean,
 simple interface accessible to casual and non-technical users.
 .
 This package contains a Python scripting plugin for TeXworks.
